import 'package:json_annotation/json_annotation.dart';

import '../../question_frame.dart';

part 'frame_answer.g.dart';

@JsonSerializable(explicitToJson: true)
class FrameAnswer {
  @JsonKey(name: "moduleId")
  final int moduleId;

  @JsonKey(name: "userResponse")
  List<FrameUserResponse> userResponseList;

  @JsonKey(name: "remarks")
  final String remarks;

  FrameAnswer(this.moduleId, this.userResponseList, this.remarks);

  factory FrameAnswer.fromJson(Map<String, dynamic> json) =>
      _$FrameAnswerFromJson(json);
  Map<String, dynamic> toJson() => _$FrameAnswerToJson(this);

  String getAnswerByTag(String tag) {
    if (tag.isNotEmpty) {
      return userResponseList
          .firstWhere((response) => response.tag == tag)
          .userInput;
    } else {
      return "$tag tag not found";
    }
  }

  int getIntAnswerByTag(String tag) {
    if (tag.isNotEmpty) {
      String value;
      try {
        value = userResponseList
            .firstWhere((response) => response.tag == tag)
            .userInput;
      } catch (e) {
        value = '-1';
      }

      return int.tryParse(value) ?? -1;
    } else {
      return -99;
    }
  }
}
