import 'package:json_annotation/json_annotation.dart';

import 'option.dart';
part 'user_response.g.dart';

@JsonSerializable()
class FrameUserResponse {
  final int qId;

  List<FrameOption> options;

  String userInput;

  String qType;

  String? tag;

  FrameUserResponse(
      {required this.qId,
      this.options = const [],
      this.userInput = '',
      required this.qType,
      this.tag});

  bool userHasResponded() {
    if (qType.toLowerCase() == "label") {
      return true;
    }

    if (userInput.isNotEmpty || options.isNotEmpty) {
      return true;
    }
    return false;
  }

  void clearResponse() {
    options.clear();
    userInput = '';
  }

  String getKey(String mId) {
    return 'm_${mId}_q_$qId';
  }

  factory FrameUserResponse.fromJson(Map<String, dynamic> json) =>
      _$FrameUserResponseFromJson(json);
  Map<String, dynamic> toJson() => _$FrameUserResponseToJson(this);
}
