import 'package:flutter/foundation.dart';
import 'package:question_frame/src/model/question.dart';
import 'package:question_frame/src/model/user_response.dart';
import 'package:question_frame/src/types/post_validation_keys.dart';

class PostValidator {
  postValidate(MapEntry<FrameQuestion, FrameUserResponse> entry) {
    final postValidateKeys = entry.key.onLoad;

    if (postValidateKeys.isNotEmpty) {
      entry = validate(entry, postValidateKeys);
    }

    return entry;
  }

  MapEntry<FrameQuestion, FrameUserResponse> validate(
      MapEntry<FrameQuestion, FrameUserResponse> entry, String keys) {
    List<String> postValidateKeys = keys.split("<#>");

    List<PostValidationKeys> pvKeys = postValidateKeys
        .map(
          (keyString) => PostValidationKeys.values.firstWhere(
            (element) => keyString == describeEnum(element),
          ),
        )
        .toList();

    for (PostValidationKeys pvKey in pvKeys) {
      entry = validateKeyword(entry, pvKey);
    }

    return entry;
  }

  MapEntry<FrameQuestion, FrameUserResponse> validateKeyword(
      MapEntry<FrameQuestion, FrameUserResponse> entry,
      PostValidationKeys pvKey) {
    switch (pvKey) {
      case PostValidationKeys.validateName:
        return entry;
      case PostValidationKeys.validateEmail:
        return entry;

      case PostValidationKeys.validateAge:
        return entry;
    }
  }
}
