import 'package:flutter/foundation.dart';
import 'package:question_frame/src/model/question.dart';
import 'package:question_frame/src/model/user_response.dart';
import 'package:question_frame/src/types/pre_validation_keys.dart';

class PreValidator {
  preValidate(MapEntry<FrameQuestion, FrameUserResponse> entry) {
    final preValidateKeys = entry.key.onLoad;

    if (preValidateKeys.isNotEmpty) {
      entry = validate(entry, preValidateKeys);
    }

    return entry;
  }

  MapEntry<FrameQuestion, FrameUserResponse> validate(
      MapEntry<FrameQuestion, FrameUserResponse> entry, String keys) {
    List<String> preValidateKeys = keys.split("<#>");

    List<PreValidatorKeys> pvKeys = preValidateKeys
        .map(
          (keyString) => PreValidatorKeys.values.firstWhere(
            (element) => keyString == describeEnum(element),
          ),
        )
        .toList();

    for (PreValidatorKeys pvKey in pvKeys) {
      entry = validateKeyword(entry, pvKey);
    }

    return entry;
  }

  MapEntry<FrameQuestion, FrameUserResponse> validateKeyword(
      MapEntry<FrameQuestion, FrameUserResponse> entry,
      PreValidatorKeys pvKey) {
    switch (pvKey) {
      case PreValidatorKeys.replace:
        return entry;
      case PreValidatorKeys.calToday:
        return entry;
    }
  }
}
