import 'package:flutter/material.dart';

import '../model/question.dart';
import '../model/user_response.dart';

class QuestionWidget extends StatelessWidget {
  final FrameQuestion question;
  final FrameUserResponse response;
  final VoidCallback swipeLeft;
  final VoidCallback swipeRight;
  final Widget child;
  const QuestionWidget({
    Key? key,
    required this.swipeLeft,
    required this.swipeRight,
    required this.child,
    required this.question,
    required this.response,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onHorizontalDragEnd: (details) {
        //swipeLeft
        if (details.primaryVelocity!.compareTo(0) == -1) {
          swipeLeft();
        }
        // swipeRight
        else if (details.primaryVelocity!.compareTo(0) == 1) {
          swipeRight();
        }
      },
      child: child,
    );
  }
}
